image: docker:20.10
services:
  - docker:20.10-dind

variables:
  IMAGE_TAG: $CI_COMMIT_SHORT_SHA

stages:
  - build
  - deployment
  - cleanup

before_script:
    - echo "Starting CI/CD"
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY

Build:
  stage: build
  script:
    - docker build -t $CI_REGISTRY_IMAGE:$IMAGE_TAG -t $CI_REGISTRY_IMAGE:latest --build-arg base_url=$BACKEND_URL .
    - docker push $CI_REGISTRY_IMAGE:latest
    - docker push $CI_REGISTRY_IMAGE:$IMAGE_TAG

Deployment:
  stage: deployment
  image: python:slim-bullseye
  before_script:
    - 'which ssh-agent || ( apt-get update -y && apt-get install openssh-client -y )'
    - mkdir -p ~/.ssh
    - eval $(ssh-agent -s)
    - '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
  script:
    - ssh-add <(echo "$STAGING_PRIVATE_KEY")
    - ssh -p22 ec2-user@$BACKEND_IP << ENDSSH
    - docker pull $CI_REGISTRY_IMAGE:latest
    - docker run -p 80:8080 -e DATASOURCE_URL='$DATASOURCE_URL' -e DATASOURCE_USERNAME=$DATASOURCE_USERNAME -e DATASOURCE_PASSWORD=$DATASOURCE_PASSWORD -d $CI_REGISTRY_IMAGE:latest
    - ENDSSH
  # when: manual/

CleanUp:
  stage: cleanup
  script:
    - docker system prune -a -f
  when: manual


